% Routines for visual inspection of grid geometry and field properties.
%
% Files
%  boundaryFaces         - Extract boundary faces from set of grid cells.
%  outlineCoarseGrid     - Impose outline of coarse grid on existing grid plot.
%  plotBlockAndNeighbors - Plot a coarse block and its neighbors to current axes (reversed Z axis).
%  plotCellData          - Plot exterior grid faces, coloured by given data, to current axes.
%  plotContours          - Plot contours of cell data.
%  plotFaceData          - Plot face data on exterior grid faces to current axes (reversed Z axis).
%  plotFaces             - Plot selection of coloured grid faces to current axes (reversed Z axis).
%  plotFaults            - Plot faults in model
%  plotGrid              - Plot exterior grid faces to current axes (reversed Z axis).
%  plotGridVolumes       - Plot partially transparent isosurfaces for a set of values
%  plotSlice             - Plot Cartesian slices of cell data on faces
%  plotWell              - Plot well trajectories into current axes.

%{
#COPYRIGHT#
%}
